/*******************************************************************************
 *
 * File Name: ANNexperienceClass.h
 * Author: Richard Baxter
 * Project: Advanced Neural Network (ANN)
 * Project Version: 1l3j 2-Sept-08
 * Comments:
 *
 *******************************************************************************/




#ifndef HEADER_ANN_EXPERIENCE_CLASS
#define HEADER_ANN_EXPERIENCE_CLASS


#define MAX_EXPERIENCE_SIGNIFICANT_BITS (20)

class ExperienceInput
{
public:

	ExperienceInput(void);
	~ExperienceInput(void);

	double inputValue;
	ExperienceInput * next;
};



class Experience
{
public:

	Experience(void);
	~Experience(void);

	long classTargetValue;

	ExperienceInput * firstExperienceInput;

	Experience * next;

};


Experience * findExperience(Experience * firstExperienceInDataSet, long experienceNumToFind);
long countNumberOfExperienceInputs(Experience * experience);
long countNumberOfExperiences(Experience * firstExperienceInList);



#endif

